/*
 *
 *   Copyright (c) 1999 - 2011 my-Channels Ltd
 *   Copyright (c) 2012 - 2017 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.
 *
 *   Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG.
 *
 */

////////////////////////////////////////////////////////////////////
// FXTile logic - Logic for the FX Trade tiles - associated functions and graphical updates.
////////////////////////////////////////////////////////////////////
	
	function FXTile (fullName,name,bid,offer) {
	this.fullName=fullName;
	this.bid=bid;
	this.offer=offer;
	this.name=name;
	this.amount=1000;
}

function sendTradeMessage(action, stockIndex, size, price) {

    var evt = Nirvana.createEvent();
    var dict = evt.getDictionary();

	dict.putString("trader", myNick);
	if(action=="sell"){
		dict.putString("sellAmount", size);
		dict.putString("buyAmount", Math.round(size*price*100)/100);	//JavaScript doesn't provide rounding to set decimal places. So for 2.d.p. we shift it 2 places decimally, roud it, and shift it back.
	
	}
	else{
		dict.putString("sellAmount", Math.round(size*price*100)/100);	//JavaScript doesn't provide rounding to set decimal places. So for 2d.p. we shift it 2 places decimally, roud it, and shift it back.
		dict.putString("buyAmount", size);
	}
	var buyCCY;
	var sellCCY;
	var first = stockIndex.substr(0,3);
	var second = stockIndex.substr(3,3);
	if(action=="buy"){
		buyCCY=first;
		sellCCY=second;
	}
	else{
		sellCCY=first;
		buyCCY=second;
	}
	dict.putString("buyCCY",buyCCY);
	dict.putString("sellCCY",sellCCY);
	dict.putDouble("rate", price);
		
	//var evt = new nConsumeEvent("tradeevent");
	//evt.setDictionary(dict);
	evt.setTag("tradeevent");
	stockIndexTradesChannel.publish(evt);
}

FXTile.prototype.buy = function(name){
	this.amount=$("#"+name+"amount").val();
	if(isNaN(parseInt(this.amount))){
		alert("Trade size must be an integer.");
	}
	else{
		sendTradeMessage("buy",name, this.amount, this.offer);
	}
};

FXTile.prototype.sell = function(name){
	this.amount=$("#"+name+"amount").val();
	if(isNaN(parseInt(this.amount))){
		alert("Trade size must be an integer.");
	}
	else{
		sendTradeMessage("sell",name, this.amount, this.bid);
	}
};

FXTile.prototype.update = function(bid,offer) {

	var offerStr = offer.toString();
	var bidStr = bid.toString();
	while(offerStr.length<7){offerStr=offerStr+"0"}
	while(bidStr.length<7){bidStr=bidStr+"0"}
	$("#buyLink"+this.name).html("ask<br/><span class='spot' onmouseover=\"this.style.cursor='pointer'\"><sub>"+offerStr.substr(0,3)+"</sub>"+offerStr.substr(3,2)+"<sup><b>"+offerStr.substr(5,3)+"</b></sup></span>");
	$("#sellLink"+this.name).html("bid<br/><span class='spot' onmouseover=\"this.style.cursor='pointer'\"><sub>"+bidStr.substr(0,3)+"</sub>"+bidStr.substr(3,2)+"<sup><b>"+bidStr.substr(5,3)+"</b></sup></span>");
	
	if(this.bid!=bid){
		if(this.buytimer){clearTimeout(this.buytimer);}
		if(bid>this.bid){
			document.getElementById(this.name+"sell").className = "button green";
		}
		else{
			document.getElementById(this.name+"sell").className = "button red";
		}
		var resetfunc = "reset('"+this.name+"sell')";
		this.buytimer=setTimeout(resetfunc, 5000);
	}
	
	if(this.offer!=offer){
		if(this.selltimer){
			clearTimeout(this.selltimer);
		}
		if(offer>this.offer){
			document.getElementById(this.name+"buy").className = "button red";
		}
		else{
			document.getElementById(this.name+"buy").className = "button green";
		}
		//var resetfunc= "reset('buyLink"+this.name+"')";
		var resetfunc2= "reset('"+this.name+"buy')";
		this.selltimer=setTimeout(resetfunc2, 5000);
	}
	this.bid=bid;
	this.offer=offer;
};

FXTile.prototype.getCollapsed = function() {
	return "<div id='"+this.name+"collapsed' class='collapsed' onclick='restore(\""+this.name+"\")'>"+this.fullName+"</div>";
};

FXTile.prototype.getHTML = function() {
		var titlebar= "<div class='FXTitleBar' id="+this.name+"titlebar>"+this.fullName+"</div>";
		
		var closeCall = 'closeTile("'+this.name+'")';
		
		var closebutton = "<span class='closeButtonSpan' onclick='"+closeCall+"'><a> </a> </span>";
		
		var buybutton ="<div class='button' id='"+this.name+"buy' style='position:relative;left:10px;'><span onclick='buy(\""+this.name+"\");' id='buyLink"+this.name+"' style='width:100%;height:100%;  display: block;color:#ddd;'></span></div>";
		
		var sellbutton="<div id='"+this.name+"sell' class='button' style='position:relative;left:20px;'> <span onclick='sell(\""+this.name+"\");' id='sellLink"+this.name+"' style='width:100%;height:100%;  display: block;color:#ddd;'></span></div>";
		
		var inputbox= "<input type='text' id='"+this.name+"amount' class='tradeSizeBox' value='1000'/>";
		
		var currencyname= "<div style='float:left;color:#fff;position:relative;left:23px;top:23px;'>"+this.name.substr(0,3)+"</div>";

	return ("<div id='"+this.name+"' class='FXTile'>"+titlebar+closebutton+buybutton+sellbutton+inputbox+currencyname+"</div>");
};

function reset(name){
	var elem = document.getElementById(name);
	if(elem){
		elem.className = "button";
	}
}

	function restore(name){
	$("#"+name).show();
	$("#"+name+"collapsed").remove();
}